##################################
### GBan.tcl		       ###
### Version 1.4		       ###
### By Wcc		       ###
### wcc@techmonkeys.org        ###
### http://www.dawgtcl.com:81/ ###
### EFnet #|DAWG|Tcl           ###
##################################

############################################################################
### Copyright  2000 - 2002 |DAWG| Scripting Group. All rights reserved. ###
############################################################################

##########################################################################
## This script adds a global ban to the bot's banlist without using DCC ##
## chat.The format for the ban time is:                                 ##
##                                                                      ##
##    <[-h|-d|-w|-m|-y] time>                                           ##
##                                                                      ##
## For example:                                                         ##
##    !GBan Wcc 1week stupid spammer!!                                  ##
##                                                                      ##
## would ban my host for 1 week with the reason "stupid spammer!!".     ##
## "Perm" or "0" makes the ban permanent.                               ##
##########################################################################

##############
## COMMANDS ##
#########################################################################
## MSG ## /msg <bot> GBan <nick/host> <[-h|-d|-w|-m|-y] time> <reason> ##
######### Adds a ban to the bot's banlist. The time is appended to the ##
######### end of the ban reason. See below for a list of options and   ##
######### their meanings.                                              ##
#########################################################################
## PUB ## !GBan <nick/host> <[-h|-d|-w|-m|-y] time> <reason>           ##
######### Adds a ban to the bot's banlist. The time is appended to the ##
######### end of the ban reason. See below for a list of options and   ##
######### their meanings.                                              ##
#########################################################################

#################
## -h = hours  ##
## -d = days   ##
## -w = weeks  ##
## -y = years  ##
#################

######################################
## Just load the script and rehash. ##
######################################

####################
# Code begins here #
####################

if {$numversion < 1061000} { putlog "\002GBAN:\002 \002WARNING:\002 This script is intended to run on eggdrop 1.6.10 or later." }
if {[info tclversion] < 8.2} { putlog "\002GBAN:\002 \002WARNING:\002 This script is intended to run on Tcl Version 8.2 or later." }

bind pub +o !gban gban_pub
bind msg +o gban gban_msg

proc gban_gettime {text} {
	set text [split $text]
	if {[regexp perm [join $text]]} { return 0 }
	if {[set index [lsearch -exact $text "-h"]] != -1} { return [expr [lrange $text [expr $index + 1] [expr $index + 1]] * 60] }
	if {[set index [lsearch -exact $text "-d"]] != -1} { return [expr [lrange $text [expr $index + 1] [expr $index + 1]] * 1440] }
	if {[set index [lsearch -exact $text "-w"]] != -1} { return [expr [lrange $text [expr $index + 1] [expr $index + 1]] * 10080] }
	if {[set index [lsearch -exact $text "-y"]] != -1} { return [expr [lrange $text [expr $index + 1] [expr $index + 1]] * 525600] }
	return [lrange $text 1 1]
}
proc gban_pub {nick uhost hand chan text} {
	if {[lindex [split $text] 1] == ""} { putserv "NOTICE $nick :Usage: !gban <nick or hostmask> <time> <reason>" ; return }
	set time [gban_gettime $text]
	if {[onchan [lindex $text 0]]} { set banmask [maskhost [getchanhost [lindex [split $text] 0]]] } { set banmask [lindex $text 0] ; set bnck "" }
	if {$time < 1} {
		putserv "PRIVMSG $chan :Global ban added: $banmask (never expires). ([lrange [split $text] 3 end] ([clock format [clock seconds] -format "%D %I:%M %p"]))"
	} {
		putserv "PRIVMSG $chan :Global ban added: $banmask (expires in [duration [expr $time * 60]]) ([lrange [split $text] 3 end] ([clock format [clock seconds] -format "%D %I:%M %p"]))"
	}
	newban $banmask $nick "[join [lrange [split $text] 3 end]] ([clock format [clock seconds] -format "%D %I:%M %p"])" $time
	foreach c [channels] {
		foreach u [chanlist $c] {
			if {[string match [string tolower $banmask] [string tolower $u![getchanhost $u $c]]]} { putserv "KICK $c $u :[join [lrange [split $text] 3 end]]" }
		}
	}
}
proc gban_msg {nick uhost hand text} {
	if {[lindex [split $text] 1] == ""} { putserv "NOTICE $nick :Usage: /msg $::botnick <nick or hostmask> <time> <reason>" ; return }
	set time [gban_gettime $text [string tolower [join [lrange [split $text] 1 1]]]]
	if {[onchan [lindex $text 0]]} { set banmask [maskhost [getchanhost [lindex [split $text] 0]]] } { set banmask [lindex $text 0] ; set bnck "" }
	if {$time < 1} {
		putserv "NOTICE $nick :Global ban added: $banmask (never expires). ([lrange [split $text] 3 end] ([clock format [clock seconds] -format "%D %I:%M %p"]))"
	} {
		putserv "NOTICE $nick :Global ban added: $banmask (expires in [duration [expr $time * 60]]) ([lrange [split $text] 3 end] ([clock format [clock seconds] -format "%D %I:%M %p"]))"
	}
	newban $banmask $nick "[join [lrange [split $text] 3 end]] ([clock format [clock seconds] -format "%D %I:%M %p"])" $time
	foreach c [channels] {
		foreach u [chanlist $c] {
			if {[string match [string tolower $banmask] [string tolower $u![getchanhost $u $c]]]} { putserv "KICK $c $u :[join [lrange [split $text] 3 end]]" }
		}
	}
}
putlog "\002GBAN:\002 GBan Version 1.4 by Wcc is loaded."